'-------------------------------------------------------------------
'                         MGARCH tests add-in
'-------------------------------------------------------------------
'Author: Nicolas Ronderos Pulido
'Date: October of 2017
mode quiet
%object=@equaloption(("object"))
!maxq=@val(@equaloption("maxlags"))
if !maxq="" then
	!maxq=1 'Default
endif
if @hasoption("vech_residuals") then
		scalar vech_residuals_=1
	else
		scalar vech_residuals_=0 'Default
endif
scalar standarized=1 'Default
if @hasoption("cov") then 
	scalar standarized=1
endif
if @hasoption("cor") then
	scalar standarized=2
endif
if @hasoption("chol") then
	scalar standarized=3
endif
%options=%object
if %options="" then
	%object=_this.@name
	scalar vech_residuals_=0
	scalar standarized=1 
	%maxq="1"
	%menu= """Root Covariance"" ""Root Correlation"" Cholesky"
	!result=@uidialog("edit",%object,"Name of VAR or System object","edit",%maxq,"Lags to include","radio",standarized,"Standarized residuals using",%menu,"check",vech_residuals_,"Save VECH residual series","text","Written by: Nicolas Ronderos (2017)","caption","MGARCH tests")
	if !result=-1 then
		d vech_residuals_ standarized
		stop
	endif
	!maxq=@val(%maxq)
endif
%type={%object}.@type
%var=%object
%sys=%object
if %type="VAR" then
	!K={%var}.@neqn
	%resid=""
	for !i=1 to !K
		%resid=%resid+" res_"+@str(!i)+" "
	next
	{%var}.makeresid {%resid}
	scalar obs={%var}.@regobs
else if {%sys}.@method="ARCH" then
		!K={%sys}.@neqn
		%resid=""
		for !i=1 to !K
			%resid=%resid+" res_"+@str(!i)+" "
		next
		if standarized=1 then
		{%sys}.makeresids(cov) {%resid}
		endif
		if standarized=2 then
		{%sys}.makeresids(cor) {%resid}
		endif
		if standarized=3 then
		{%sys}.makeresids(chol) {%resid}
		endif
		scalar obs={%sys}.@regobs
		else
		@uiprompt("The object does not contain MGARCH estimates")
		d vech_residuals_ standarized
		stop
	endif
endif
'VECH residuals of the VAR or SYS
group group_res {%resid}
stom(group_res,uti)
matrix uti=@transpose(uti)
for !i=1 to @obs(res_1)
	for !j=1 to !K
		vector(!K,1) ut(!j,1)=uti(!j,!i)
	next
	vector ut2=@vech(ut*@transpose(ut))
	for !w=1 to !K*(1+!K)/2
		matrix(!K*(1+!K)/2,@obs(res_1)) vech_ut2(!w,!i)=ut2(!w,1)
	next
next
matrix vech_ut2=@transpose(vech_ut2)
'LM-ARCH test
group sigma
for !i=1 to !K*(1+!K)/2
	genr vechut!i=NA
	group sigma sigma vechut!i
	%series=%series+" vechut"+@str(!i)
next
string sample=@otod(obs)
sample s1 @first {sample}
mtos(vech_ut2,sigma,s1)
%resid=""
for !j=1 to !K*(1+!K)/2
	%dependent=@word(%series,!j)
	equation eq!j.ls {%dependent} c
	eq!j.makeresid resid_!j
	%resid=%resid+" resid_"+@str(!j)
next
group covariance {%resid}
covariance.cov(out=cov_0)
%lags=""
%resid=""
vector(!maxq) statistic=0
vector(!maxq) pv=0
vector(!maxq) df=0
for !i=1 to !maxq
	for !j=1 to !K*(1+!K)/2
			%lags=%lags+" "+@word(%series,!j)+"(-"+@str(!i)+") "
	next
	for !j=1 to !K*(1+!K)/2
		%dependent=@word(%series,!j)
		equation eq!j.ls {%dependent} c {%lags}
		eq!j.makeresid resid_!j
		%resid=%resid+" resid_"+@str(!j)
	next
	group covariance {%resid}
	%resid=""
	covariance.cov(out=cov_q)
	vector(!maxq) statistic(!i,1)=(@obs(resid_1)*!K*(!K+1)/2)-@obs(resid_1)*@trace(cov_qcov*@inverse(cov_0cov))
	vector(!maxq) pv(!i,1)=@chisq(statistic(!i,1),(!i*!K*!K*(!K+1)^2)/4)
	vector(!maxq) df(!i,1)=(!i*!K*!K*(!K+1)^2)/4
	d covariance cov_qcov
next
for !i= 1 to !K*(1+!K)/2
	d eq!i resid_!i vechut!i
next
d cov_0cov group_res sigma ut ut2 uti 
'Portmanteau ARCH test
matrix mean=@cmean(vech_ut2)
matrix(!K*(1+!K)/2,!K*(1+!K)/2) Ci=NA
Ci=0
for !h=0 to !maxq
	for !i=1 to @obs(res_1)
		if !i>!h then
			for !j=1 to !K*(1+!K)/2
				matrix(!K*(1+!K)/2,1) ut3(!j,1)=vech_ut2(!i,!j)
				matrix(!K*(1+!K)/2,1) ut3_r(!j,1)=vech_ut2(!i-!h,!j)
			next
			matrix(!K*(1+!K)/2,!K*(1+!K)/2) Ci=Ci+(ut3-mean)*@transpose(ut3_r-mean)
		endif
	next
	if !h=0 then
		matrix C0=Ci/@obs(res_1)
		Ci=0
		else if  !i>!h+1 then
			matrix C!h=Ci/@obs(res_1)
			Ci=0
		endif
	endif
next
vector(!maxq) Q_ARCH=0
vector(!maxq) Q_ARCH_A=0
for !h=1 to !maxq
	if !h=1 then
		vector(!maxq) Q_ARCH(!h,1)=@trace(@transpose(C!h)*@inverse(C0)*C!h*@inverse(C0))
		vector(!maxq) Q_ARCH_A(!h,1)=(@trace(@transpose(C!h)*@inverse(C0)*C!h*@inverse(C0)))/(@obs(res_1)-!h)
	else
		vector(!maxq) Q_ARCH(!h,1)=Q_ARCH(!h-1,1)+@trace(@transpose(C!h)*@inverse(C0)*C!h*@inverse(C0))
		vector(!maxq) Q_ARCH_A(!h,1)=Q_ARCH_A(!h-1,1)+(@trace(@transpose(C!h)*@inverse(C0)*C!h*@inverse(C0)))/(@obs(res_1)-!h)
	endif
next
vector(!maxq) Q_ARCH=Q_ARCH*@obs(res_1)
vector(!maxq) Q_ARCH_A=Q_ARCH_A*@obs(res_1)^2
vector(!maxq) pv_q=0
vector(!maxq) pv_qa=0
vector(!maxq) df_=0
if %type="VAR" then
	scalar P={%var}.@lagcount
else
	scalar P=({%sys}.@eqncoef(1)-1)/!K
endif
for !h=1 to !maxq
	if !h<=P then
		vector(!maxq) pv_q(!h)=NA
		vector(!maxq) pv_qa(!h)=NA
		vector(!maxq) df_(!h)=NA
	else
		vector(!maxq) pv_q(!h)=@chisq(Q_ARCH(!h),!K*(1+!K)/2*!K*(1+!K)/2*(!h-P))
		vector(!maxq) pv_qa(!h)=@chisq(Q_ARCH_A(!h),!K*(1+!K)/2*!K*(1+!K)/2*(!h-P))
		vector(!maxq) df_(!h)=!K*(1+!K)/2*!K*(1+!K)/2*(!h-P)
	endif
next
for !i=1 to !K
	d res_!i 
next
'Table
%table="MGARCH_test"
if @isobject("MGARCH_test") then
	%table=@getnextname(%table)
endif
table(!maxq+8,9) {%table}
setcell({%table},1,1,"ARCH-LM and ARCH-Portmanteau test for MGARCH models")
setcell({%table},2,1,"Null Hypothesis: no M-ARCH effects up to lag q")
setcell({%table},4,1,"Lag")
setcell({%table},4,2,"LM Stat")
setcell({%table},4,3,"P-value")
setcell({%table},4,4,"Df")
setcell({%table},4,5,"Portmanteau Stat")
setcell({%table},4,6,"P-value*")
setcell({%table},4,7,"Adj Portmanteau Stat")
setcell({%table},4,8,"P-value*")
setcell({%table},4,9,"Df*")
setcell({%table},!maxq+7,1,"*The probability of the test can only be calculated for lags greater than the VAR lag order")
if %type="SYSTEM" then
	if standarized=1 then
		%stand="square root of covariance"
		else if standarized=2 then
				%stand="square root of correlation"
			else
				%stand="Cholesky of covariance"
		endif
	endif
	%st="Standarized residuals using "+%stand
	setcell({%table},!maxq+8,1,%st)
endif
{%table}.setwidth(1) 5
{%table}.setwidth(2) 10
{%table}.setwidth(3) 7
{%table}.setwidth(4) 5
{%table}.setwidth(5) 17
{%table}.setwidth(6) 7
{%table}.setwidth(7) 20
{%table}.setwidth(8) 7
{%table}.setwidth(9) 5
{%table}.label(r) Author of the program: Nicolas Ronderos Pulido.
setline({%table},3)
setline({%table},5)
setline({%table},!maxq+6)
for !i=1 to !maxq
	{%table}(!i+5,1)=!i
	{%table}.setformat(!i+5,1) f.0
	{%table}(!i+5,2)=statistic(!i,1)
	{%table}.setformat(!i+5,2) f.4
	{%table}(!i+5,3)=pv(!i,1)
	{%table}.setformat(!i+5,3) f.2
	{%table}(!i+5,4)=df(!i,1)
	{%table}.setformat(!i+5,4) f.0
	{%table}(!i+5,5)=Q_ARCH(!i,1)
	{%table}.setformat(!i+5,5) f.4
	{%table}(!i+5,6)=pv_q(!i,1)
	{%table}.setformat(!i+5,6) f.2
	{%table}(!i+5,7)=Q_ARCH_A(!i,1)
	{%table}.setformat(!i+5,7) f.4
	{%table}(!i+5,8)=pv_qa(!i,1)
	{%table}.setformat(!i+5,8) f.2
	{%table}(!i+5,9)=df_(!i,1)
	{%table}.setformat(!i+5,9) f.0
next
if vech_residuals_=1 then
	%vech_res="vech_res"
	if @isobject("vech_res") then
		%vech_res=@getnextname(%vech_res)
	endif
	freeze({%vech_res}) vech_ut2.line
	{%vech_res}.legend columns(5)
	{%vech_res}.legend position(BOTCENTER)
	%table="VECH_residuals"
	if @isobject("VECH_residuals") then
		%table=@getnextname(%table)
	endif
	table(obs+1,!K*(!K+1)/2) {%table}
	for !i=1 to obs
		for !j=1 to !K*(!K+1)/2
			{%table}(!i+1,!j)=vech_ut2(!i,!j)
		next
	next
	{%table}.setwidth(@all) 28
	{%table}.setheight(1) 2
	{%table}.setfillcolor(1) @rgb(9, 79, 164)
	{%table}.settextcolor(1) white
	{%table}.setlines(@all) +a
	{%table}.label(r) Author of the program: Nicolas Ronderos Pulido.
	!loop=0
	for !i=1 to !K
		for !j=1 to !K
			if !i<=!j then
				!loop=!loop+1
				if !i=!j then
					{%table}(1,!loop)="Var("+@str(!i)+")"
					%legend="Var("+@str(!i)+")"
					{%vech_res}.setelem(!loop) legend({%legend})
				else
					{%table}(1,!loop)="Cov("+@str(!i)+","+@str(!j)+")"
					%legend="Cov("+@str(!i)+","+@str(!j)+")"
					{%vech_res}.setelem(!loop) legend({%legend})
				endif
			endif
		next
	next
endif
d df df_ mean obs p pv pv_q pv_qa q_arch q_arch_a s1 sample statistic ut3 ut3_r vech_ut2 ci vech_residuals_ standarized
for !i=0 to !maxq
	d c!i
next


